package test;

import java.util.Iterator;
import java.util.LinkedList;

import com.itheima.util.LoopList;

/**
 * 对LoopList进行测试
 * 
 * @author mrng
 * 
 */
public class test {
	public static void main(String[] args) {
		LinkedList<Integer> ls = new LinkedList<Integer>();
		ls.add(1);
		ls.add(1);
		ls.set(1, 2);

		// 测试对象
		LoopList<String> list = new LoopList<String>(3); // 设置对列大小为 3

		// 测试CRUD
		testCrud(list);

		// 测试ForEach
		testFor(list);

		// 测试clear
		// list.clear();

		// 测试Iterator
		testIterator(list);

		// 测试contains
		System.out.println("-----测试contains-----");
		System.out.println(list.contains("one"));
		System.out.println(list.contains("four"));

		// 测试remove
		System.out.println("-----测试remove-----");
		System.out.println(list.removeFirst());
		System.out.println(list.removeLast());

		// 测试set
		// System.out.println("-----测试set-----");
		// 如果访问到了不存在的索引位，则会抛出异常
		// list.set(1, "six");

		// 测试toArray()
		System.out.println("-----测试toArray()-----");
		Object[] arr1 = list.toArray();
		for (Object o : arr1) {
			System.out.println(o);
		}

		// 测试toArray(T[] a)
		System.out.println("-----测试toArray(T[] a)-----");
		String[] arr2 = (String[]) list.toArray(new String[] { "1", "2", "3",
				"4", "5" });
		for (String s : arr2) {
			System.out.println(s);
		}

		System.out.println("size = " + list.getSize());
		// 测试Iterator的remove
		testIteratorRemove(list);
		System.out.println("size = " + list.getSize());

		// 测试Iterator
		testIterator(list);
	}

	// 测试Iterator的// 测试Iterator
	public static void testIteratorRemove(LoopList<String> list) {
		System.out.println("-----测试Iterator的remove-----");
		Iterator<String> it = list.iterator();
		// 这里会抛出异常----
		// it.remove();
		while (it.hasNext()) {
			String value = it.next();
			if ("four".equals(value)) {
				it.remove();
			}
			System.out.println(value);
		}
		// 删除next返回的最后一个元素
		// it.remove();
		// 这里会抛出异常----
		// it.remove();
		// System.out.println(it.next());
	}

	// 测试CRUD
	public static void testCrud(LoopList<String> list) {
		System.out.println("-----测试CRUD-----");
		list.add("one"); // 添加第1个对象
		list.add("two"); // 添加第2个对象
		list.add("three"); // 添加第3个对象
		list.add("four"); // 添加第4个对象、由于队列大小为3，所以，第4个对象会将第1个对象挤出去。

		System.out.println(list.getFirst()); // 打印结果为 "two"
		System.out.println(list.getChildAt(1)); // 打印结果为 "three"

		list.add("five"); // 继续添加会将当前的第1个对象挤出去。

		System.out.println(list.getFirst()); // 打印结果为 "three"
		System.out.println(list.getChildAt(1)); // 打印结果为 "four"
	}

	// 测试ForEach
	public static void testFor(LoopList<String> list) {
		System.out.println("-----测试ForEach-----");
		for (String s : list) {
			System.out.println(s);
		}
	}

	// 测试Iterator
	public static void testIterator(LoopList<String> list) {
		System.out.println("-----测试Iterator-----");
		Iterator<String> it = list.iterator();
		while (it.hasNext()) {
			String value = it.next();
			System.out.println(value);
		}
	}

}
